<?php

/**
 * quiz.php
 *
 * @author Michael Gruber <michael.gruber@chello.at>
 * @copyright Copyright &copy; 2004, Michael Gruber
 * @version 0.1 (2004-12-03)
**/
session_start();

// read questions
if (empty($_SESSION['questions'])) {
	$a_questions = file($_REQUEST['questions']);
	$_SESSION['false'] = 0;
	$_SESSION['correct'] = 0;
	$_SESSION['jokerpub'] = true;
	$_SESSION['joker50t'] = true;
	$_SESSION['jokertel'] = true;
	
	foreach ($a_questions as $a_question) {
		$a_question = str_replace('""', '"', $a_question);
		$a = explode(';', $a_question);
		$a_tmp = array();
		$a_tmp['question'] = trim($a[0]);
		$a_tmp['answer'][1] = trim($a[1]);
		$a_tmp['answer'][2] = trim($a[2]);
		$a_tmp['answer'][3] = trim($a[3]);
		$a_tmp['answer'][4] = trim($a[4]);
		$a_tmp['status'] = '';
		$_SESSION['questions'][] = $a_tmp;
	}
}

if (!empty($_REQUEST['choose_joker_pub'])) {
	$_SESSION['jokerpub'] = false;
}
if (!empty($_REQUEST['choose_joker_tel'])) {
	$_SESSION['jokertel'] = false;
}
if (!empty($_REQUEST['choose_joker_50t'])) {
	$_SESSION['joker50t'] = false;
}

$i_question 	= (int) $_REQUEST['question_id'];

?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
	<title>PHPQuiz</title>
	<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
	<style>
		body 			{background-color: #000000}
		body, table 	{font-family:Arial,Verdana; font-size:16pt; color:#CCCCCC}
		.char 			{color:#FFCC00; font-weight:bold; font-size:20pt}
		.question		{background-image:url(images/question.gif); color:#FFFFFF; font-size:20pt; padding-left: 5px; padding-right: 5px }
		.cell 			{background-image:url(images/cell.gif); color:#FFFFFF; cursor:pointer; padding-left: 5px; padding-right: 5px}
		.answer		{color:#FFFFFF}
		.correct		{font-size: 32pt; font-weight:bold; color:#33FF00;}
		.false			{font-size: 32pt; font-weight:bold; color:#FF0000;}
		
		p {font-size: 10pt; font-color: #999999;}
		a, a:visited, a:active { color: 3300FF}
		a:hover { color: #FFFFFF}
	</style>
	<script language="JavaScript">
		function jokerTel() {
			document.getElementById('joker_tel').style.display = 'none';
			document.getElementById('choose_joker_tel').value = 'true';
		}
		
		function joker50t() {
			document.getElementById('joker_50t').style.display = 'none';
			document.getElementById('cell_3').innerHTML = '';
			document.getElementById('cell_3').className = '';
			document.getElementById('cell_4').innerHTML = '';
			document.getElementById('cell_4').className = '';
			
			document.getElementById('choose_joker_50t').value = 'true';
		}
		
		function jokerPub() {
			document.getElementById('joker_pub').style.display = 'none';
			document.getElementById('choose_joker_pub').value = 'true';
		}
	</script>
</head>
<body>

	<center>
	<form name="post" method="POST" action="quiz.php">
<?php

if (isset($_REQUEST['answer_id'])) {
	$i_question = (int) $_REQUEST['question_id'];
	$i_answer	= (int) $_REQUEST['answer_id'];
	$b_status = $i_answer === 1 ? true : false;
	
	$_SESSION['questions'][$i_question]['status'] = $b_status;
	
	if ($b_status) {
		$_SESSION['correct']++;
		echo '<p class="correct">RICHTIG</p>';
	}
	else {
		$_SESSION['false']++;
		echo '<p class="false">Leider FALSCH</p>';
	}
	
	$i_question++;
	$a_questions 	= $_SESSION['questions'];
	
	if (count($a_questions) > $i_question) {
		?>
		<input type="hidden" name="question_id" value="<?=$i_question?>">
		<button type="submit" style="font-size: 20pt">weiter mit der nchsten Frage</button>
		<?php
	}
	else {
		echo $_SESSION['correct'] . ' richtige Antwort' . ($_SESSION['correct'] != 1 ? 'en' : '') . '<br/>';
		echo $_SESSION['false'] . ' falsche Antwort' . ($_SESSION['false'] != 1 ? 'en' : '') . '<br/><br/>';
		
		?>
		<table cellpadding="4" cellspacing="4" class="stats">
			<?php 
				for ($n=count($a_questions)-1; $n>=O; $n--) { 
					$m = $n+1;
			?>
			<tr>
				<td align="right"><?php echo $m ?>.</td>
				<td>Frage &nbsp; &nbsp;</td>
				<td>
					<?php if ($a_questions[$n]['status'] === true) { ?>
					<font color="#33FF00">richtig</font>
					<?php } ?>
					<?php if ($a_questions[$n]['status'] === false) { ?>
					<font color="#FF0000">falsch</font>
					<?php } ?>	
				</td>
			</tr>
			<?php } ?>
		</table>
		<?php

	}
	
	
}
else {

	$a_questions 	= $_SESSION['questions'];
	#print_r($_SESSION);
	
	function shuffle_me($shuffle_me) {
	   $randomized_keys = array_rand($shuffle_me, count($shuffle_me));
	   foreach($randomized_keys as $current_key) {
		   $shuffled_me[$current_key] = $shuffle_me[$current_key];
	   }
	   return $shuffled_me;
	} 
	
	
	?>
	
		<?php
			$a_numbers = array(1, 2, 3, 4);
			$a_shuffle = shuffle_me($a_numbers);
		?>
		
		<input type="hidden" id="question_id" name="question_id" value="<?php echo $i_question ?>">
		<input type="hidden" id="answer_id" name="answer_id">
		
		<input type="hidden" id="choose_joker_pub" name="choose_joker_pub">
		<input type="hidden" id="choose_joker_tel" name="choose_joker_tel">
		<input type="hidden" id="choose_joker_50t" name="choose_joker_50t">
		
		
		
		<table cellpadding="0" cellspacing="15">
			<tr>
				<td valign="bottom">
		
					<table width="930" cellpadding="0" cellspacing="10">
						<tr>
							<td style="font-size:20pt">noch <?php echo count($a_questions) - $i_question; ?> Fragen <p><a href="index.php">neu beginnen</a></p></td>
							<td height="53" align="right">
								<?php if ($_SESSION['jokerpub']) 
									echo '<img id="joker_pub" src="images/jokerpubt.gif" width="83" height="53" style="cursor:pointer;" onClick="jokerPub()">'; ?>
								<?php if ($_SESSION['jokertel']) 
									echo '<img id="joker_tel" src="images/jokertelt.gif" width="83" height="53" style="cursor:pointer;" onClick="jokerTel()">'; ?>
								<?php if ($_SESSION['joker50t']) 
									echo '<img id="joker_50t" src="images/joker50t.gif" width="83" height="53" style="cursor:pointer;" onClick="joker50t()">'; ?>
							</td>
						</tr>
						<tr>
							<td colspan="2" width="910" height="150" class="question" align="center"><?php echo $a_questions[$i_question]['question']; ?></td>
						</tr>
						<?php 
						$n = 0;
						foreach ($a_shuffle as $i) { 
							if ($n%2 == 0) echo '<tr>';
							switch ($n) {
								case 0: $s_char = 'A'; break;
								case 1: $s_char = 'B'; break;
								case 2: $s_char = 'C'; break;
								case 3: $s_char = 'D'; break;
							}
							?>
							<td width="450" height="150" id="cell_<?=$i?>" class="cell" onClick="document.getElementById('answer_id').value=<?=$i?>; document.post.submit();">
								<table width="100%">
									<tr>
										<td width="40" align="right" class="char"><?=$s_char?></td>
										<td align="center" class="answer"><?=$a_questions[$i_question]['answer'][$i]?></td>
									</tr>
								</table>
							</td>
							<?php
							if ($n%2 == 1) echo '</tr>';
							$n++;
						?>
						
						<?php } ?>
					</table>
				
				</td>
			</tr>
		</table>
		
	<?php } ?>
	
	<p>PHPquiz &copy; by Michael Gruber 2004 <br/> Fragen an <a href="mailto:michael@webspell.at">michael@webspell.at</a></p>
	
	</form>
	</center>
</body>
</html>